<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Submit' => '\\StructType\\Submit',
            'SubmitResponse' => '\\StructType\\SubmitResponse',
            'SubmitTransport' => '\\StructType\\SubmitTransport',
            'SubmitTransportResponse' => '\\StructType\\SubmitTransportResponse',
            'SubmitXML' => '\\StructType\\SubmitXML',
            'SubmitXMLResponse' => '\\StructType\\SubmitXMLResponse',
            'ExtractFirst' => '\\StructType\\ExtractFirst',
            'ExtractFirstResponse' => '\\StructType\\ExtractFirstResponse',
            'ExtractNext' => '\\StructType\\ExtractNext',
            'ExtractNextResponse' => '\\StructType\\ExtractNextResponse',
            'ConvertFile' => '\\StructType\\ConvertFile',
            'ConvertFileResponse' => '\\StructType\\ConvertFileResponse',
            'UploadFile' => '\\StructType\\UploadFile',
            'UploadFileResponse' => '\\StructType\\UploadFileResponse',
            'DownloadFile' => '\\StructType\\DownloadFile',
            'DownloadFileResponse' => '\\StructType\\DownloadFileResponse',
            'RegisterResource' => '\\StructType\\RegisterResource',
            'RegisterResourceResponse' => '\\StructType\\RegisterResourceResponse',
            'ListResources' => '\\StructType\\ListResources',
            'ListResourcesResponse' => '\\StructType\\ListResourcesResponse',
            'DeleteResource' => '\\StructType\\DeleteResource',
            'DeleteResourceResponse' => '\\StructType\\DeleteResourceResponse',
            'RetrieveResource' => '\\StructType\\RetrieveResource',
            'RetrieveResourceResponse' => '\\StructType\\RetrieveResourceResponse',
            'UploadFileAppend' => '\\StructType\\UploadFileAppend',
            'UploadFileAppendResponse' => '\\StructType\\UploadFileAppendResponse',
            'Transport' => '\\StructType\\Transport',
            'vars' => '\\StructType\\Vars',
            'subnodes' => '\\StructType\\Subnodes',
            'attachments' => '\\StructType\\Attachments',
            'Var' => '\\StructType\\_Var',
            'multipleStringValues' => '\\StructType\\MultipleStringValues',
            'multipleLongValues' => '\\StructType\\MultipleLongValues',
            'multipleDoubleValues' => '\\StructType\\MultipleDoubleValues',
            'BusinessData' => '\\StructType\\BusinessData',
            'externalVars' => '\\StructType\\ExternalVars',
            'Attachment' => '\\StructType\\Attachment',
            'convertedAttachments' => '\\StructType\\ConvertedAttachments',
            'XMLDescription' => '\\StructType\\XMLDescription',
            'SessionHeader' => '\\StructType\\SessionHeader',
            'SubNode' => '\\StructType\\SubNode',
            'subNodes' => '\\StructType\\SubNodes_1',
            'ExtractionHeader' => '\\StructType\\ExtractionHeader',
            'ExtractionResult' => '\\StructType\\ExtractionResult',
            'transports' => '\\StructType\\Transports',
            'Resources' => '\\StructType\\Resources',
            'resources' => '\\StructType\\Resources_1',
            'BusinessRules' => '\\StructType\\BusinessRules',
            'WSFile' => '\\StructType\\WSFile',
            'SubmissionResult' => '\\StructType\\SubmissionResult',
            'ConversionResult' => '\\StructType\\ConversionResult',
            'ConversionParameters' => '\\StructType\\ConversionParameters',
            'SubmissionResults' => '\\StructType\\SubmissionResults',
            'transportIDs' => '\\StructType\\TransportIDs',
            'ExtractionParameters' => '\\StructType\\ExtractionParameters',
        );
    }
}
