<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Delete ServiceType
 * @subpackage Services
 */
class Delete extends AbstractSoapClientBase
{
    /**
     * Sets the SessionHeaderValue SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\SessionHeader $sessionHeaderValue
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderSessionHeaderValue(\StructType\SessionHeader $sessionHeaderValue, $nameSpace = 'urn:SubmissionService2', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'SessionHeaderValue', $sessionHeaderValue, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named DeleteResource
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: SessionHeaderValue
     * - SOAPHeaderNamespaces: urn:SubmissionService2
     * - SOAPHeaderTypes: \StructType\SessionHeader
     * - SOAPHeaders: required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteResource $parameters
     * @return \StructType\DeleteResourceResponse|bool
     */
    public function DeleteResource(\StructType\DeleteResource $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->DeleteResource($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\DeleteResourceResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
