<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConversionResult StructType
 * @subpackage Structs
 */
class ConversionResult extends AbstractStructBase
{
    /**
     * The convertedFile
     * @var \StructType\WSFile
     */
    public $convertedFile;
    /**
     * Constructor method for ConversionResult
     * @uses ConversionResult::setConvertedFile()
     * @param \StructType\WSFile $convertedFile
     */
    public function __construct(\StructType\WSFile $convertedFile = null)
    {
        $this
            ->setConvertedFile($convertedFile);
    }
    /**
     * Get convertedFile value
     * @return \StructType\WSFile|null
     */
    public function getConvertedFile()
    {
        return $this->convertedFile;
    }
    /**
     * Set convertedFile value
     * @param \StructType\WSFile $convertedFile
     * @return \StructType\ConversionResult
     */
    public function setConvertedFile(\StructType\WSFile $convertedFile = null)
    {
        $this->convertedFile = $convertedFile;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConversionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
