<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for convertedAttachments StructType
 * @subpackage Structs
 */
class ConvertedAttachments extends AbstractStructBase
{
    /**
     * The WSFile
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\WSFile[]
     */
    public $WSFile;
    /**
     * Constructor method for convertedAttachments
     * @uses ConvertedAttachments::setWSFile()
     * @param \StructType\WSFile[] $wSFile
     */
    public function __construct(array $wSFile = array())
    {
        $this
            ->setWSFile($wSFile);
    }
    /**
     * Get WSFile value
     * @return \StructType\WSFile[]|null
     */
    public function getWSFile()
    {
        return $this->WSFile;
    }
    /**
     * Set WSFile value
     * @throws \InvalidArgumentException
     * @param \StructType\WSFile[] $wSFile
     * @return \StructType\ConvertedAttachments
     */
    public function setWSFile(array $wSFile = array())
    {
        foreach ($wSFile as $convertedAttachmentsWSFileItem) {
            // validation for constraint: itemType
            if (!$convertedAttachmentsWSFileItem instanceof \StructType\WSFile) {
                throw new \InvalidArgumentException(sprintf('The WSFile property can only contain items of \StructType\WSFile, "%s" given', is_object($convertedAttachmentsWSFileItem) ? get_class($convertedAttachmentsWSFileItem) : gettype($convertedAttachmentsWSFileItem)), __LINE__);
            }
        }
        $this->WSFile = $wSFile;
        return $this;
    }
    /**
     * Add item to WSFile value
     * @throws \InvalidArgumentException
     * @param \StructType\WSFile $item
     * @return \StructType\ConvertedAttachments
     */
    public function addToWSFile(\StructType\WSFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSFile) {
            throw new \InvalidArgumentException(sprintf('The WSFile property can only contain items of \StructType\WSFile, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->WSFile[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConvertedAttachments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
