<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetrieveResource StructType
 * @subpackage Structs
 */
class RetrieveResource extends AbstractStructBase
{
    /**
     * The resourceName
     * @var string
     */
    public $resourceName;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The published
     * @var bool
     */
    public $published;
    /**
     * The eMode
     * @var string
     */
    public $eMode;
    /**
     * Constructor method for RetrieveResource
     * @uses RetrieveResource::setResourceName()
     * @uses RetrieveResource::setType()
     * @uses RetrieveResource::setPublished()
     * @uses RetrieveResource::setEMode()
     * @param string $resourceName
     * @param string $type
     * @param bool $published
     * @param string $eMode
     */
    public function __construct($resourceName = null, $type = null, $published = null, $eMode = null)
    {
        $this
            ->setResourceName($resourceName)
            ->setType($type)
            ->setPublished($published)
            ->setEMode($eMode);
    }
    /**
     * Get resourceName value
     * @return string|null
     */
    public function getResourceName()
    {
        return $this->resourceName;
    }
    /**
     * Set resourceName value
     * @param string $resourceName
     * @return \StructType\RetrieveResource
     */
    public function setResourceName($resourceName = null)
    {
        // validation for constraint: string
        if (!is_null($resourceName) && !is_string($resourceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($resourceName)), __LINE__);
        }
        $this->resourceName = $resourceName;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @uses \EnumType\RESOURCE_TYPE::valueIsValid()
     * @uses \EnumType\RESOURCE_TYPE::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\RetrieveResource
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\RESOURCE_TYPE::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $type, implode(', ', \EnumType\RESOURCE_TYPE::getValidValues())), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get published value
     * @return bool|null
     */
    public function getPublished()
    {
        return $this->published;
    }
    /**
     * Set published value
     * @param bool $published
     * @return \StructType\RetrieveResource
     */
    public function setPublished($published = null)
    {
        // validation for constraint: boolean
        if (!is_null($published) && !is_bool($published)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($published)), __LINE__);
        }
        $this->published = $published;
        return $this;
    }
    /**
     * Get eMode value
     * @return string|null
     */
    public function getEMode()
    {
        return $this->eMode;
    }
    /**
     * Set eMode value
     * @uses \EnumType\WSFILE_MODE::valueIsValid()
     * @uses \EnumType\WSFILE_MODE::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $eMode
     * @return \StructType\RetrieveResource
     */
    public function setEMode($eMode = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\WSFILE_MODE::valueIsValid($eMode)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $eMode, implode(', ', \EnumType\WSFILE_MODE::getValidValues())), __LINE__);
        }
        $this->eMode = $eMode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RetrieveResource
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
