<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubmitXML StructType
 * @subpackage Structs
 */
class SubmitXML extends AbstractStructBase
{
    /**
     * The xml
     * @var \StructType\XMLDescription
     */
    public $xml;
    /**
     * Constructor method for SubmitXML
     * @uses SubmitXML::setXml()
     * @param \StructType\XMLDescription $xml
     */
    public function __construct(\StructType\XMLDescription $xml = null)
    {
        $this
            ->setXml($xml);
    }
    /**
     * Get xml value
     * @return \StructType\XMLDescription|null
     */
    public function getXml()
    {
        return $this->xml;
    }
    /**
     * Set xml value
     * @param \StructType\XMLDescription $xml
     * @return \StructType\SubmitXML
     */
    public function setXml(\StructType\XMLDescription $xml = null)
    {
        $this->xml = $xml;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubmitXML
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
