<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subnodes StructType
 * @subpackage Structs
 */
class Subnodes extends AbstractStructBase
{
    /**
     * The SubNode
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SubNode[]
     */
    public $SubNode;
    /**
     * Constructor method for subnodes
     * @uses Subnodes::setSubNode()
     * @param \StructType\SubNode[] $subNode
     */
    public function __construct(array $subNode = array())
    {
        $this
            ->setSubNode($subNode);
    }
    /**
     * Get SubNode value
     * @return \StructType\SubNode[]|null
     */
    public function getSubNode()
    {
        return $this->SubNode;
    }
    /**
     * Set SubNode value
     * @throws \InvalidArgumentException
     * @param \StructType\SubNode[] $subNode
     * @return \StructType\Subnodes
     */
    public function setSubNode(array $subNode = array())
    {
        foreach ($subNode as $subnodesSubNodeItem) {
            // validation for constraint: itemType
            if (!$subnodesSubNodeItem instanceof \StructType\SubNode) {
                throw new \InvalidArgumentException(sprintf('The SubNode property can only contain items of \StructType\SubNode, "%s" given', is_object($subnodesSubNodeItem) ? get_class($subnodesSubNodeItem) : gettype($subnodesSubNodeItem)), __LINE__);
            }
        }
        $this->SubNode = $subNode;
        return $this;
    }
    /**
     * Add item to SubNode value
     * @throws \InvalidArgumentException
     * @param \StructType\SubNode $item
     * @return \StructType\Subnodes
     */
    public function addToSubNode(\StructType\SubNode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubNode) {
            throw new \InvalidArgumentException(sprintf('The SubNode property can only contain items of \StructType\SubNode, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SubNode[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Subnodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
