<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for vars StructType
 * @subpackage Structs
 */
class Vars extends AbstractStructBase
{
    /**
     * The Var
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\_Var[]
     */
    public $Var;
    /**
     * Constructor method for vars
     * @uses Vars::setVar()
     * @param \StructType\_Var[] $var
     */
    public function __construct(array $var = array())
    {
        $this
            ->setVar($var);
    }
    /**
     * Get Var value
     * @return \StructType\_Var[]|null
     */
    public function getVar()
    {
        return $this->Var;
    }
    /**
     * Set Var value
     * @throws \InvalidArgumentException
     * @param \StructType\_Var[] $var
     * @return \StructType\Vars
     */
    public function setVar(array $var = array())
    {
        foreach ($var as $varsVarItem) {
            // validation for constraint: itemType
            if (!$varsVarItem instanceof \StructType\_Var) {
                throw new \InvalidArgumentException(sprintf('The Var property can only contain items of \StructType\_Var, "%s" given', is_object($varsVarItem) ? get_class($varsVarItem) : gettype($varsVarItem)), __LINE__);
            }
        }
        $this->Var = $var;
        return $this;
    }
    /**
     * Add item to Var value
     * @throws \InvalidArgumentException
     * @param \StructType\_Var $item
     * @return \StructType\Vars
     */
    public function addToVar(\StructType\_Var $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\_Var) {
            throw new \InvalidArgumentException(sprintf('The Var property can only contain items of \StructType\_Var, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Var[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Vars
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
